/*
 * Numeric conversion helpers
 *
 * Copyright 1996-2002 netFluid Technology Ltd
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Revision: 1.1.1.1 $  $Date: 2003/01/10 23:16:00 $
 * ---------------------------------------------------------------------------
 */

#include <phlib/xl_config.h>
#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <phlib/xl_types.h>
#include <phlib/xl_ipaddr.h>

/* ----------------------------------------------------------------------- */

char *
xl_get_IPAddr_str(char *buff, ulong addr) 
{
  register uchar_t *b;
  uchar_t *a = (uchar_t *)&addr;
  register int z;

  b = (uchar_t*)buff;

  z = byte_to_ip_tab[ a[0] ];

  switch( z & 0xff ) {
  case 3: *b++ = ( z = z>>8 );
  case 2: *b++ = ( z = z>>8 );
  case 1: *b++ = ( z = z>>8 );
  }
  *b++ = '.';

  z = byte_to_ip_tab[ a[1] ];
  switch( z & 0xff ) {
  case 3: *b++ = ( z = z>>8 );
  case 2: *b++ = ( z = z>>8 );
  case 1: *b++ = ( z = z>>8 );
  }
  *b++ = '.';

  z = byte_to_ip_tab[ a[2] ];
  switch( z & 0xff ) {
  case 3: *b++ = ( z = z>>8 );
  case 2: *b++ = ( z = z>>8 );
  case 1: *b++ = ( z = z>>8 );
  }
  *b++ = '.';

  z = byte_to_ip_tab[ a[3] ];
  switch( z & 0xff ) {
  case 3: *b++ = ( z = z>>8 );
  case 2: *b++ = ( z = z>>8 );
  case 1: *b++ = ( z = z>>8 );
  }
  *b++ = '\0';

  return buff;
}

/* ----------------------------------------------------------------------- */
/* end */
