/*
 * Memory storage handling
 *
 * Copyright 1996-2002 netFluid Technology Ltd
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Revision: 1.1.1.1 $  $Date: 2003/01/10 23:16:02 $
 * ---------------------------------------------------------------------------
 */

#include <phlib/xl_config.h>
#include <phlib/xl_types.h>

/* --------------------------------------------------------------------- */

void
store_int32_LittleEndian( uchar_t *ptr, int32 v )
{
  *(ptr + 0) =       v & 0xFF;
  *(ptr + 1) = (v>>8)  & 0xFF;
  *(ptr + 2) = (v>>16) & 0xFF;
  *(ptr + 3) = (v>>24) & 0xFF;
}

/* --------------------------------------------------------------------- */

int32
read_int32_LittleEndian( uchar_t *ptr )
{
  return *(ptr+0) | (*(ptr+1)<<8) | (*(ptr+2)<<16) | (*(ptr+3)<<24);
}


/* --------------------------------------------------------------------- */

void
store_int32_BigEndian( uchar_t *ptr, int32 l )
{
  *(ptr + 3) =       l & 0xFF;
  *(ptr + 2) = (l>>8)  & 0xFF;
  *(ptr + 1) = (l>>16) & 0xFF;
  *(ptr + 0) = (l>>24) & 0xFF;
}

/* --------------------------------------------------------------------- */

int32
read_int32_BigEndian( uchar_t *ptr )
{
  return *(ptr+3) | (*(ptr+2)<<8) | (*(ptr+1)<<16) | (*(ptr+0)<<24);
}
/* --------------------------------------------------------------------- */

void
store_int16_LittleEndian( uchar_t *ptr, int16 v )
{
  *(ptr + 0) =      v & 0xFF;
  *(ptr + 1) = (v>>8) & 0xFF;
}

/* --------------------------------------------------------------------- */

int16
read_int16_LittleEndian( uchar_t *ptr )
{
  return *(ptr+0) | (*(ptr+1)<<8);
}


/* --------------------------------------------------------------------- */
/* end */
